package it.purser.stream;

import android.app.Activity;
import android.content.Intent;
import android.net.Uri;
import android.os.Bundle;
import java.util.TreeMap;
import java.util.Locale;

public class ShareActivity extends Activity {
    private class Upstream {
        private Uri uri = null;
        private String provider = null;
        private String direct = null;
        private Upstream(Uri uri, String provider, boolean direct) {
            this.uri = uri;
            this.provider = provider;
            this.direct = direct ? "true" : "false";
        }
    }
    private Upstream getSharedLink() {
        TreeMap<String,String> domains = new TreeMap<>();
        domains.put("youtu.be", "youtube");
        domains.put("youtube.com", "youtube");
        domains.put("www.youtube.com", "youtube");
        domains.put("tv.nrk.no", "nrk");
        domains.put("nx12210.your-storageshare.de", "nextcloud");

        Intent intent = getIntent();
        Bundle bundle = intent.getExtras();
        for(String key: bundle.keySet()) {
            try {
                String txt = (String) bundle.get(key);
                Uri uri = Uri.parse(txt);
                String host = uri.getHost().toLowerCase(Locale.ROOT);
                if(domains.containsKey(host)) {
                    boolean direct = host.contains("youtu.be");
                    if(host.contains("youtube.com")) {
                        Uri.Builder builder = new Uri.Builder();
                        builder.authority(host);
                        builder.scheme("https");
                        String path = uri.getQueryParameter("v");
                        if(path != null) {
                            builder.path(path);
                            return new Upstream(builder.build(), domains.get(host), true);
                        }
                    }
                    return new Upstream(uri, domains.get(host), direct);
                }
            } catch(Exception e) {}
        }
        return null;
    }
    @Override
    protected void onCreate(Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);
        Upstream upstream = getSharedLink();
        if(upstream != null) {
            Uri.Builder builder = new Uri.Builder();
            builder.authority("stream.purser.it");
            builder.scheme("https");
            builder.path(upstream.uri.getPath());
            builder.appendQueryParameter("provider", upstream.provider);
            builder.appendQueryParameter("direct", upstream.direct);
            Intent launch = new Intent(Intent.ACTION_VIEW, builder.build());
            launch.setPackage("com.android.chrome");
            launch.putExtra("android.support.customtabs.extra.SESSION", "Proxy Stream");
            launch.putExtra("android.support.customtabs.extra.TOOLBAR_COLOR", 0xff0000);
            startActivity(launch);
        }
        finish();
    }
}
